/*
 *    Sierpinski - Gitter (nicht optimal, aber funktionstuechtig)
 *
 *    name   :   bonds.c
 *    compile:   cc bonds.c -o bonds
 *    start  :	 bonds 3
 *
 *     (c) J. Schulenburg 1996 (Author uebernimmt keine Haftung fuer nichts)
 */


#include <stdio.h>
#include <stdlib.h>

#define Bufsize 10000 /* must be greater than number of bonds */

int g[2][Bufsize][2];
int ecke[2][3];

main(int argn,char *argv[]){
   int t,tmax,d,i,j,k,s,b,buf,b2,site;
   tmax=3; /* MAX-Tiefe */
   if(argn==2)tmax=atoi(argv[1]);
   t=0;
   d=1;  /* anzahl kleinste dreiecke */
   s=3;  /* sites */
   b=3;  /* bonds */
   buf=0;
   g[buf][0][0]=0;
   g[buf][0][1]=1;
   g[buf][1][0]=1;
   g[buf][1][1]=2;
   g[buf][2][0]=2;
   g[buf][2][1]=0;
   ecke[buf][0]=0;  /* unten links */
   ecke[buf][1]=1;  /* unten rechts */
   ecke[buf][2]=2;  /* oben */
   for(t=1;t<tmax;t++){
     for(j=0;j<b;j++)for(k=0;k<2;k++){  /* 1. dreieck unten links */
        site=g[buf][j][k];
        g[1-buf][j][k]=site;}
     b2=b; 
     for(j=0;j<b;j++)for(k=0;k<2;k++){  /* 1. dreieck unten rechts */
        site=g[buf][j][k];
        if(site==ecke[buf][0]){ site=ecke[buf][1]; } 
        else { if(site >ecke[buf][0])site--; site+=s; };
        g[1-buf][j+b][k]=site;
        }
     b2=2*b; 
     for(j=0;j<b;j++)for(k=0;k<2;k++){  /* 1. dreieck oben */
        site=g[buf][j][k];
        if(site==ecke[buf][0]){ site=ecke[buf][2]; }  else
        if(site==ecke[buf][1]){ site=ecke[buf][2]; 
                 
               if(site>ecke[buf][0])site--; site+=s;}  
        else {  
               if(site >ecke[buf][1])site-=2;else 
               if(site >ecke[buf][0])site--; site+=(s-1)+s;};
        g[1-buf][j+2*b][k]=site;
        }
     ecke[1-buf][0]=ecke[buf][0];
     site=ecke[buf][1]+(s-1);      ecke[1-buf][1]=site; 
     site=ecke[buf][2]+(s-1)+(s-2);ecke[1-buf][2]=site; 
     buf=1-buf;
     s+=3*d;
     b*=3;
     d*=3;
     printf("tiefe=%2d minidreiecke=%8d sites=%8d bonds=%8d\n",t,d,s,b);}
     printf(" Ecken: %d %d %d\nBonds:\n",ecke[buf][0],ecke[buf][1],ecke[buf][2]);
     for(i=0;i<b;i++)
       printf("%8d : %8d -- %8d\n",i,g[buf][i][0],g[buf][i][1]);
   }


